function [wsol,residual,lambda] = getConvergenceData(w0,data)
 
% Set up shared variables with OUTFUN
residual = [];
lambda = [];
% Solver settings
options_fsolve = optimoptions(@fsolve,'Display','iter',...
     'MaxIterations',20e3,'MaxFunEvals',1e10,...
     'stepTolerance',1e-13,'FunctionTolerance',1e-13,...
     'specifyObjectiveGradient', true,...
     'OptimalityTolerance',1e-13, 'Algorithm','levenberg-marquardt',...
     'OutputFcn',@outfun);
% call solver
wsol = fsolve(@(w)HEX(1,w,data),w0,options_fsolve);

% outfun stores the residual and lambda at each iteration
 function stop = outfun(x,optimValues,state)
     stop = false;
     switch state
         case 'iter'
         % Concatenate current residual and lambda
         % value with history
           residual = [residual; sum(abs(optimValues.fval))];
           lambda = [lambda; optimValues.lambda];
         otherwise
     end
 end
end
 