function plotConvergence(residual,iterations,condNr,Q,index)
markerSet = {'-','--',':','-','--',':'};
ColorSet = [0 0.4470 0.7410;0.8500 0.3250 0.0980];
set(0,'defaulttextInterpreter','latex','DefaultAxesFontName',...
 'Times New Roman','DefaultTextFontname', 'Times New Roman','DefaultLineLineWidth',4,...
 'defaultAxesFontSize',50)
% Stop at i = 421 because of temperature in outlet.
figure(1)
y_max = max(iterations)+10;
plot(Q,iterations);
hold on
for i = 1:length(index)
    plot([Q(index(i)),Q(index(i))],[0,y_max],'k--','lineWidth',2);
end
ylim([0 y_max]);
xlim([-4.2 -3.5]);
ylabel('Nr Iterations', 'interpreter','latex')
xlabel('Q [MW]')

figure(2)
y_max = max(iterations)+10;
plot(Q,iterations);
hold on
for i = 1:length(index)
    plot([Q(index(i)),Q(index(i))],[0,y_max],'k--','lineWidth',2);
end
ylim([0 y_max]);
xlim([-0.8 -0]);
ylabel('Nr Iterations', 'interpreter','latex')
xlabel('Q [MW]')

figure(3)
semilogy(Q(1:421),iterations(1:421))
ylim([0 y_max]);
xlim([-4.2 0]);
xlabel('Q [MW]')
ylabel('Nr Iterations')

y_max = max(condNr);
figure(4)
plot(Q(1:421),condNr(1:421));
hold on
for i = 1:length(index)
    plot([Q(index(i)),Q(index(i))],[0,y_max+2e8],'k--','lineWidth',2);
end
xlim([-4.2 0]);
ylim([0 y_max]);
ylabel('$\kappa$(G)', 'interpreter','latex')
xlabel('Q [MW]')


figure(5)
semilogy(0:iterations(20)-1,residual{20})
hold on
semilogy(0:iterations(29)-1,residual{29})
semilogy(0:iterations(57)-1,residual{57})
semilogy(0:iterations(384)-1,residual{384})
legend({'N_{VL} = 0 \rightarrow 1', 'N_{VL} = 1 \rightarrow 2',...
    'N_{VL} = 2 \rightarrow 3', 'N_{VL} = 3 \rightarrow 2'},...
    'fontSize',30)
ylabel('$|| \mathbf{f}(\mathbf{x}) ||_1$')
xlabel('Iteration nr.')

figure(6)
semilogy(0:iterations(100)-1,residual{100})
ylabel('$|| \mathbf{f}(\mathbf{x}) ||_1$')
xlabel('Iteration nr.')

end